module OpenEHR
  module RM
    module Support
      module Definition
        class Object_ID
          attr_accessor :value
          def initiallize(value)
            if value == nil
              raise Exception.new("empty value")
            end
            @value = value
          end
        end # of ObjectID
        class Terminology_ID < Object_ID
          attr_reader :name
          def initialize(arg0, arg1=nil)
            if arg1 == nil
              super(arg0)
            else
              super(toValue(arg0, arg1))
              @name = arg0
              @version = arg1      
            end
          end
          def setValue(value)
            loadValue(value)
            super.value = value
          end
          def version_id
            @version
          end
          private
          def loadValue(value)
            if /\(.*\)$/ =~ value
              @name, @version = value.split(\())
              @version.chop!
            else
              @name = value
              @version = nil
            end
          end
          def toValue(name, version)
            if name == ""
              raise Exception.new("empty name")
            end
            name + (version == nil ? "" : "(" + version + ")")
          end
        end # of TerminologyID
      end # of Definition
    end # of Support
  end # of RM
end # of OpenEHR
